package com.compass.gps;

import java.text.Format;
import java.text.SimpleDateFormat;
import java.util.Date;

import android.app.Activity;
import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.widget.TextView;

public class GPSActivity extends Activity implements LocationListener, SensorEventListener{

	private static final double VARICAO = 0.000005;
	private static final long TEMPO_ESPERA_GPS = 5000;
	LocationManager lm;
	Location lastLocation;
	Location atualLocation;
	float distancia;
	
	TextView dist;
	TextView posicaoAtual;
	TextView ultimaPosicao;
	TextView data;
	
	Format f;
	Date lastDate;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_gps);
        
        dist = (TextView) findViewById(R.id.distancia);
        posicaoAtual = (TextView) findViewById(R.id.posicaoAtual);
        ultimaPosicao = (TextView) findViewById(R.id.ultimaPosicao);
        data = (TextView) findViewById(R.id.data);
        
        f = new SimpleDateFormat("HH:mm:ss");
        
        lm = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
    	lm.requestLocationUpdates(LocationManager.GPS_PROVIDER, TEMPO_ESPERA_GPS, 0, this);
    	
    	
    	Location locationA = new Location("point A");

    	locationA.setLatitude(0.0);
    	locationA.setLongitude(0.0);

    	Location locationB = new Location("point B");

    	locationB.setLatitude(0.0);
    	locationB.setLongitude(0.1);

    	float distance = locationA.distanceTo(locationB);
    	
    	dist.setText("Distancia = " + distance);
    	
    }

	public void onLocationChanged(Location location) {
		if(atualLocation == null){
			atualLocation = location;
			lastLocation = new Location(location);
			Date date = new Date();
			lastDate = date;
			data.setText(f.format(date));
		}
		else{
			lastLocation.set(location);
			atualLocation.set(location);
			atualLocation.setLatitude(location.getLatitude() + VARICAO);
			atualLocation.setLongitude(location.getLongitude() + VARICAO);
			lastLocation.setLatitude(location.getLatitude() - VARICAO);
			lastLocation.setLongitude(location.getLongitude() - VARICAO);
			distancia = lastLocation.distanceTo(atualLocation);
			ultimaPosicao.setText(lastLocation.getLatitude() + "  " + lastLocation.getLongitude());
			dist.setText(Float.toString(distancia));
			Date date = new Date();
			data.setText(f.format(date) + "  "  + f.format(lastDate));
			lastDate = date;
		}
		
		posicaoAtual.setText(atualLocation.getLatitude() + "  " + atualLocation.getLongitude());
	}

	public void onProviderDisabled(String provider) {
		
	}

	public void onProviderEnabled(String provider) {
		
	}

	public void onStatusChanged(String provider, int status, Bundle extras) {
		
	}

	public void onAccuracyChanged(Sensor sensor, int accuracy) {
		
	}

	public void onSensorChanged(SensorEvent event) {
		
	}

    
}
