package com.example.communicationbyorientation;

import java.io.FileWriter;
import java.io.IOException;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Enumeration;
import java.util.Timer;
import java.util.TimerTask;

import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.app.Activity;
import android.content.Context;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;

public class AzimuthTest extends Activity implements LocationListener, SensorEventListener{
	private SensorManager mSensorManager = null;
	private Location location;
	
	Button btIniciar;
	Button btParar;
	RadioGroup rdGroupIds;
	RadioButton rd0Ini,rd25cm,rd50cm,rd1m,rd2m;
	RadioButton rd4m,rd8m,rd16m,rd32m,rd0Fim;
	RadioButton rdCustomerId;
	FileWriter fileOutput;
	DateFormat dateFormat;
	TimerTask timerTaskSample;
	TimerTask timerTaskFinishSample;
	Timer timerSample;
	
	TextView tvLatitude;
	TextView tvLongitude;
	TextView tvAcuracia;
	TextView tvDate;
	TextView tvCronometer;
	TextView tvLog;
	TextView txtModel;
	TextView txtIMEI;
	
	EditText etSecondsToStop;
	EditText etCustomerId;
	EditText etEvent;
	
	String periodSample;
	String deviceName;
	String devideIMEI;
	
	public double lastLat;
	public double lastLng;
	float lastAccuracy;
	
	private LocationManager lm;

	boolean iniciarLog;
	boolean fim;
	
	Date lastDate;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_azimuthtest);
    
        location = null;
        
        btIniciar = (Button) findViewById(R.id.btIniciar);
        btParar = (Button) findViewById(R.id.btFinalizar);
        
        rdGroupIds = (RadioGroup) findViewById(R.id.radioGroupIds); 
        rd0Ini = (RadioButton) findViewById(R.id.radio0mIn);
        rd25cm = (RadioButton) findViewById(R.id.radio25cm);
        rd50cm = (RadioButton) findViewById(R.id.radio50cm);
        rd1m = (RadioButton) findViewById(R.id.radio1m);
        rd2m = (RadioButton) findViewById(R.id.radio2m);
        rd4m = (RadioButton) findViewById(R.id.radio4m);
        rd8m = (RadioButton) findViewById(R.id.radio8m);
        rd16m = (RadioButton) findViewById(R.id.radio16m);
        rd32m = (RadioButton) findViewById(R.id.radio32m);
        rd0Fim = (RadioButton) findViewById(R.id.radio0mFim);
        rdCustomerId = (RadioButton) findViewById(R.id.rdCustomerId);
        
        tvLatitude = (TextView) findViewById(R.id.txtLatitude);
        tvLongitude = (TextView) findViewById(R.id.txtLongitude);
        tvAcuracia = (TextView) findViewById(R.id.txtAcuracia);
        tvDate = (TextView) findViewById(R.id.txtDate);
        tvCronometer = (TextView) findViewById(R.id.tvCronometer);
        txtModel = (TextView) findViewById(R.id.txtModel);
        txtIMEI = (TextView) findViewById(R.id.txtIMEI);
        
        etSecondsToStop = (EditText) findViewById(R.id.etSecondsToStop);
        etCustomerId = (EditText) findViewById(R.id.etCustomerId);
        etEvent = (EditText) findViewById(R.id.etEvento);
        tvLog = (TextView) findViewById(R.id.tvLog);
        
        lm = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
        lm.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, this);
        
		timerSample = new Timer();
        
        dateFormat = new SimpleDateFormat("dd/MM/yyyy hh:mm:ss.SSS");
        
        iniciarLog = false;
        
        deviceName = getDeviceName();
        devideIMEI = getIMEI();
        txtModel.setText(deviceName);
        txtIMEI.setText(devideIMEI);
        
        btIniciar.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View v) {
            	iniciarLog = true;
            	
            	Log.i("etSecondsToStop",(Long.parseLong(etSecondsToStop.getText().toString())*1000)+"");
            	
            	if(timerTaskSample != null)
            		timerTaskSample.cancel();
            	
            	if(timerTaskFinishSample != null)
            		timerTaskFinishSample.cancel();
            	
            	timerTaskSample = new TimerTask() {
        			private int periodInSeconds = 0;
        			private Handler handler = new Handler();
                	
        			@Override
        			public void run() {
        				// TODO Auto-generated method stub
        				handler.post(new Runnable() {
        					
        					@Override
        					public void run() {
        						// TODO Auto-generated method stub
        						periodInSeconds++;
        						periodSample = periodInSeconds + " segundo(s)";
        						tvCronometer.setText(periodSample);
        					}
        				});
        			}
        		};

            	timerTaskFinishSample = new TimerTask() {
        			private Handler handler = new Handler();
                	
        			@Override
        			public void run() {
        				// TODO Auto-generated method stub
        				handler.post(new Runnable() {
        					@Override
        					public void run() {
        						// TODO Auto-generated method stub
        						iniciarLog = false;
        						timerTaskSample.cancel();
        						timerTaskFinishSample.cancel();
        					}
        				});
        			}
        		};
        		
        		//simulation
        		/*location = new Location(LocationManager.GPS_PROVIDER);
        		location.setLatitude(10.00);
        		location.setLongitude(12.00);
        		location.setAccuracy(30f);
        		location.setTime(new Date().getTime());*/
        		
        		updateDataInFile(location,fileOutput,"botaoIniciar");
        		
            	timerSample.schedule(timerTaskSample, 0,1000);
            	timerSample.schedule(timerTaskFinishSample,Long.parseLong(etSecondsToStop.getText().toString())*1000,1000);
            	//Long.parseLong(etSecondsToStop.getText().toString())*1000
            }
        });
        
        btParar.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				iniciarLog = false;
				timerTaskSample.cancel();
				timerTaskFinishSample.cancel();
				
				timerTaskSample = null;
				timerTaskFinishSample = null;
			}
		});
		mSensorManager = (SensorManager) this.getSystemService(SENSOR_SERVICE);
		
        try{
			fileOutput = new FileWriter("/sdcard/gpsExperimento.txt", true);
        }
        catch(Exception e){
        	e.printStackTrace();
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }
    
    @Override
    public void onStop(){
    	super.onStop();
    }
    
	@Override
	public void onAccuracyChanged(Sensor sensor, int accuracy) {
		// TODO Auto-generated method stub
	}

	public void deactivateSensor(int sensorType){
		mSensorManager.unregisterListener(this,mSensorManager.getDefaultSensor(sensorType));
	}
	
	public String distanciaSelecionada(){
		if(rdCustomerId.isChecked())
			return etCustomerId.getText().toString();
		if(rd0Ini.isChecked())
			return "Ini";
		if(rd25cm.isChecked())
			return "25cm";
		if(rd50cm.isChecked())
			return "50cm";
		if(rd1m.isChecked())
			return "1m";
		if(rd2m.isChecked())
			return "2m";
		if(rd4m.isChecked())
			return "4m";
		if(rd8m.isChecked())
			return "8m";
		if(rd16m.isChecked())
			return "16m";
		if(rd32m.isChecked())
			return "32m";
		if(rd0Fim.isChecked())
			return "Fim";
		return "Indefinido";
	}

	public String getDeviceName() {
		  String manufacturer = Build.MANUFACTURER;
		  String model = Build.MODEL;
		  if (model.startsWith(manufacturer)) {
		    return capitalize(model);
		  } else {
		    return capitalize(manufacturer) + " " + model;
		  }
	}
	
	private String capitalize(String s) {
	  if (s == null || s.length() == 0) {
	    return "";
	  }
	  char first = s.charAt(0);
	  if (Character.isUpperCase(first)) {
	    return s;
	  } else {
	    return Character.toUpperCase(first) + s.substring(1);
	  }
	} 	
	
	public void updateDataInFile(Location location, FileWriter fileOutput, String extra){
		/*if(location == null)
			lm.requestSingleUpdate(LocationManager.GPS_PROVIDER, this, null);*/
		if(iniciarLog && location != null){
			lastLat = location.getLatitude(); 
			lastLng = location.getLongitude();
			lastAccuracy = location.getAccuracy();
			lastDate = new Date(location.getTime());
			
			tvLatitude.setText(""+lastLat);
			tvLongitude.setText(""+lastLng);
			tvAcuracia.setText(""+lastAccuracy);
			tvDate.setText(dateFormat.format(lastDate));
			
			try {
				String s = etEvent.getText().toString() + "," + 
							distanciaSelecionada() + "," +
							lastLat + "," +
							lastLng + "," +
							lastAccuracy + "," +
							dateFormat.format(new Date()) + "," +
							extra + "," + 
							deviceName + "," +
							devideIMEI + "\n";
				
				tvLog.setText(s);
				
				synchronized (fileOutput) {
					fileOutput.write(s);
					fileOutput.flush();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	@Override
	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
		this.location = location;
		updateDataInFile(location,fileOutput,"onLocationChanged");
	}

	@Override
	public void onProviderDisabled(String arg0) {
		// TODO Auto-generated method stub
	}
	
	@Override
	public void onDestroy(){
		System.exit(0);
	}

	@Override
	public void onProviderEnabled(String arg0) {
		// TODO Auto-generated method stub
	}

	@Override
	public void onStatusChanged(String arg0, int arg1, Bundle arg2) {
		// TODO Auto-generated method stub
	}

	@Override
	public void onSensorChanged(SensorEvent arg0) {
		// TODO Auto-generated method stub
	}

    public String getIMEI() {
    	TelephonyManager telephonyManager = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);
    	return telephonyManager.getDeviceId();
    }
	
	
}

