USE [TCC]
GO

UPDATE [dbo].[coletaAzimute3]
   SET [data] = replace(data,'17/01/2013','2013/01/17')
GO

UPDATE [dbo].[coletaAzimute3]
   SET [latitude] = [latitude]/10
 WHERE [latitude] < -24 or latitude>-23

UPDATE [dbo].[coletaAzimute3]
   SET [longitude] = [longitude]/10
 WHERE [longitude] < -47 or [longitude]>-46


GO

delete from [TCC].[dbo].[coletaAzimute3] where id in (SELECT id
FROM [TCC].[dbo].[coletaAzimute3] AS C1 WHERE experimento = 'AzmSolNuv9'
and datediff(SECOND,
	(SELECT MIN(DATA) FROM coletaAzimute3 AS C2 
		WHERE C2.[experimento] = C1.[experimento] and C2.posicao = C1.posicao and C2.celular = C1.celular),
	DATA) > 10)


SELECT TOP 1 C1.celular as celularC1, c2.celular as celularC2, C1.[experimento], C1.[posicao], C1.latitude as lat1, C1.longitude as lng1, C2.latitude as lat2, C2.longitude as lng2
	INTO [TCC].[dbo].[coletaAzimuteAnalise] 
  FROM [TCC].[dbo].[coletaAzimute3] as C1 INNER JOIN [TCC].[dbo].[coletaAzimute3] as C2
	ON C1.[experimento] = C2.[experimento] and C1.[posicao] = C2.[posicao] and C1.celular <> C2.celular
	where C1.experimento in ('AzmSolNuv9','AzmSolNuv11')
	order by C1.[experimento],C1.[posicao],C1.celular 


	-- sincronizando os tempos
SELECT datediff(SECOND,C1.[data],C2.[data]) diferenca,C1.experimento, C1.posicao
  FROM [TCC].[dbo].[coletaAzimuteClean] as C1 INNER JOIN [TCC].[dbo].[coletaAzimute3] as C2
	ON C1.[experimento] = C2.[experimento] and C1.[posicao] = C2.[posicao] and C1.celular <> C2.celular
WHERE C1.[evento] = 'botaoIniciar' and C2.[evento] = 'botaoIniciar'


SELECT  C1.experimento, C1.posicao, (SELECT (CASE WHEN datediff(SECOND,C1.[data],C2.[data]) > 0 THEN DATEADD(SECOND,datediff(SECOND,C1.[data],C2.[data]),C1.[DATA])  ELSE C1.[data] END)
			  FROM [TCC].[dbo].[coletaAzimute3] AS C2
				WHERE C2.[experimento] = C1.[experimento] and C2.[posicao] = C1.[posicao] and C2.celular <> C1.celular
					 and C2.[evento] = 'botaoIniciar')  
		FROM [dbo].[coletaAzimute3] AS C1
		WHERE  C1.[evento] = 'botaoIniciar'


/*UPDATE [TCC].[dbo].[coletaAzimute3]
SET evento = 'onLocationChanged'
where id in(5355,5384,5385,5387)*/

/*UPDATE [TCC].[dbo].[coletaAzimute3]
SET evento = 'botaoIniciar'
where id in(1708)*/


  SELECT minAcuracia, maxAcuracia, [avgAcuracia], dpAcuracia, cntAcuracia, count(*) as #atualizacoes
  FROM [TCC].[dbo].[coletaAzimuteCleanAvg]
  group by minAcuracia, maxAcuracia, [avgAcuracia], dpAcuracia, cntAcuracia
order by [avgAcuracia]


SELECT avg(avgAcuracia) media,stdev(avgAcuracia) desvio, min(avgAcuracia) as minima, max(avgAcuracia) as maxima, experimento
  FROM [TCC].[dbo].[coletaAzimuteCleanAvg]
  group by experimento



INSERT INTO [dbo].[coletaAzimuteAnaliseTot]
           ([celularC1]
           ,[celularC2]
           ,[experimento]
           ,[posicao]
           ,[lat1]
           ,[lng1]
           ,[lat2]
           ,[lng2]
		   ,acuracia1
		   ,acuracia2)
     (SELECT C1.celular as celularC1, c2.celular as celularC2, C1.[experimento], C1.[posicao], C1.latitude as lat1, C1.longitude as lng1, C2.latitude as lat2, C2.longitude as lng2, C1.acuracia, C2.acuracia
  FROM [TCC].[dbo].[coletaAzimute3] as C1 INNER JOIN [TCC].[dbo].[coletaAzimute3] as C2
	ON C1.[experimento] = C2.[experimento] and C1.[posicao] = C2.[posicao] and C1.celular <> C2.celular) 

	UPDATE [dbo].coletaAzimuteAnaliseTotFinal5
   SET [azimute360] = (case when azimute<0 then azimute + 360 else azimute end)

   UPDATE [dbo].coletaAzimuteAnaliseTotFinal5
   SET [distance] = dbo.CalculaDistanciaGPS([lat2],[lng2],[lat1],[lng1])

   INSERT INTO [dbo].[coletaAzimuteAnaliseTotComAvgAccuracia]
           ([celularC1]
           ,[celularC2]
           ,[experimento]
           ,[posicao]
           ,[lat1]
           ,[lng1]
           ,[lat2]
           ,[lng2]
           ,[azimute]
           ,[acuracia1]
           ,[acuracia2]
           ,[azimute360]
           ,[distance])
     (SELECT [celularC1]
      ,[celularC2]
      ,[experimento]
      ,[posicao]
      ,[lat1]
      ,[lng1]
      ,[lat2]
      ,[lng2]
      ,[azimute]
      ,avg([acuracia1])
      ,avg([acuracia2])
      ,[azimute360]
      ,[distance]
  FROM [TCC].[dbo].[coletaAzimuteAnaliseTot3]
  group by celularC1,celularC2,experimento,posicao,lat1,lng1,lat2,lng2,azimute,azimute360,distance)
GO