package com.usp.clientcommunication;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.MulticastSocket;
import java.net.Socket;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class ClientActivity extends Activity {

    private EditText mensagem;
    private Button connectPhones;
    private Button verMensagens;
    private EditText ip;
    private TextView respostaServidor; 
    private boolean connected = false;
    MulticastSocket socket = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_client);

        mensagem = (EditText) findViewById(R.id.mensagem);
        connectPhones = (Button) findViewById(R.id.connect_phones);
        verMensagens = (Button) findViewById(R.id.receber);
        ip = (EditText) findViewById(R.id.ip);
        respostaServidor = (TextView) findViewById(R.id.respostaServidor);
        connectPhones.setOnClickListener(connectListener);
        
        ip.setText("192.168.43.");
        
        verMensagens.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				finish();
			}
		});
    }

    private OnClickListener connectListener = new OnClickListener() {

        public void onClick(View v) {
            if (!connected) {
                Thread cThread = new Thread(new TCPClientThread());
                cThread.start();
            }
        }
    };

    public class TCPClientThread implements Runnable {

        public void run() {
            try {
            	InetAddress serverAddr = InetAddress.getByName(ip.getText().toString());
                Log.d("ClientActivity", "C: Connecting...");
                Socket socket = new Socket(serverAddr, ServerActivity.SERVERPORT);
                connected = true;
                try {
                    Log.d("ClientActivity", "C: Sending command.");
                    DataOutputStream outToServer = new DataOutputStream(socket.getOutputStream());
                    BufferedReader inFromServer = new BufferedReader(new InputStreamReader(socket.getInputStream()));
                        // where you issue the commands
                    outToServer.writeBytes(mensagem.getText().toString());
                    String resp = inFromServer.readLine();
                    respostaServidor.setText("Resposta: " + resp);
                    Log.d("ClientActivity", "C: Sent.");
                } catch (Exception e) {
                    Log.e("ClientActivity", "S: Error", e);
                }
                socket.close();
                Log.d("ClientActivity", "C: Closed.");
            } catch (Exception e) {
                Log.e("ClientActivity", "C: Error", e);
                connected = false;
	            }
        }
    }
}

