package com.usp.clientcommunication;


import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;
import java.util.Collections;
import java.util.Enumeration;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class ServerActivity extends Activity {
String line;
    private TextView serverStatus;
    private Button voltar;
    
    // default ip
    public static String SERVERIP = null;

    // designate a port
    public static final int SERVERPORT = 8081;

    private Handler handler = new Handler();

    private ServerSocket serverSocket;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_server);
        serverStatus = (TextView) findViewById(R.id.server_status);
        voltar = (Button) findViewById(R.id.voltar);
        
        printAllIpAddress();
        Thread t = new Thread(new TCPServerThread());
        t.start();
        
        voltar.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				Intent i = new Intent(getApplicationContext(), ClientActivity.class);
		        startActivity(i);
			}
		});
    }

    public final class TCPServerThread implements Runnable {

        public void run() {
            try {
            	SERVERIP = getLocalIpAddress();
                if (SERVERIP != null) {
                    handler.post(new Runnable() {
                        public void run() {
                            serverStatus.setText("Listening on IP: " + SERVERIP);
                        }
                    });
                    serverSocket = new ServerSocket(SERVERPORT);
                    while (true) {
                        // listen for incoming clients
                        Socket client = serverSocket.accept();
                        serverStatus.setText("Connected.");
                        
                        try {
                            BufferedReader in = new BufferedReader(new InputStreamReader(client.getInputStream()));
                            DataOutputStream outToClient = new DataOutputStream(client.getOutputStream());
                            line = null;
                            while ((line = in.readLine()) != null) {
                                Log.d("ServerActivity", line);
                                serverStatus.setText(serverStatus.getText() + "\n" + line);
                                outToClient.writeBytes("Mensagem aceita!");
                            }
                        } catch (Exception e) {
                        	serverStatus.setText("Oops. Connection interrupted. Please reconnect your phones.");
                            e.printStackTrace();
                        }
                        client.close();
                    }
                } else {
                    handler.post(new Runnable() {
                        public void run() {
                            serverStatus.setText("Couldn't detect internet connection.");
                        }
                    });
                }
            } catch (Exception e) {
            	serverStatus.setText("Error");
                e.printStackTrace();
            }
        }
    }

    
    private void printAllIpAddress() {
    	try {
    		Enumeration<NetworkInterface> ifaces = NetworkInterface.getNetworkInterfaces();
    		for (NetworkInterface iface : Collections.list(ifaces)) {
    		
    		System.out.println(iface.getDisplayName() + " VIRT " + iface.getDisplayName());
    		Enumeration<InetAddress> vaddrs = iface.getInetAddresses();
    		for (InetAddress vaddr : Collections.list(vaddrs)) {
    		System.out.println("\t" + vaddr.toString());
    		}
    		
    		System.out.println("Real iface addresses: " + iface.getDisplayName());
    		Enumeration<InetAddress> raddrs = iface.getInetAddresses();
    		for (InetAddress raddr : Collections.list(raddrs)) {
    		System.out.println("\t" + raddr.toString());
    		}
    		}
        } catch (SocketException ex) {
            Log.e("ServerActivity", ex.toString());
        }
    }
    // gets the ip address of your phone's network
    private String getLocalIpAddress() {
        try {
        	int i = 1;
            for (Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces(); en.hasMoreElements();) {
                NetworkInterface intf = en.nextElement();
                System.out.println("@@@@Length: " + i++);
                for (Enumeration<InetAddress> enumIpAddr = intf.getInetAddresses(); enumIpAddr.hasMoreElements();) {
                    InetAddress inetAddress = enumIpAddr.nextElement();
                    System.out.println("@@@@@@IP: " + inetAddress.getHostAddress().toString());
                    if (!inetAddress.isLoopbackAddress()) { 
                    	return inetAddress.getHostAddress().toString(); 
                    }
                }
            }
        } catch (SocketException ex) {
            Log.e("ServerActivity", ex.toString());
        }
   
    /*try{
    InetAddress ownIP=InetAddress.getLocalHost();
    System.out.println("IP of my Android := "+ownIP.getHostAddress());
    return ownIP.getHostAddress();
    }catch (Exception e){
    System.out.println("Exception caught ="+e.getMessage());
    }*/
   
        return null;
    }
    

    @Override
    protected void onStop() {
        super.onStop();
    }
    
    @Override
    protected void onDestroy(){
    	super.onDestroy();
    	try {
            // make sure you close the socket upon exiting
            serverSocket.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}