package tcc.renato.tonny.udpcommunication;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.MulticastSocket;
import java.util.Timer;
import java.util.TimerTask;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class ClientActivity extends Activity {

	Timer timer = new Timer();
	TimerTask tt;
	final Handler handler = new Handler();
	String msg = "";
	
    private EditText mensagem;
    private Button connectPhones;
    private Button verMensagens;
    private EditText ip;
    private TextView respostaServidor; 
    MulticastSocket socket = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_client);

        mensagem = (EditText) findViewById(R.id.mensagem);
        connectPhones = (Button) findViewById(R.id.connect_phones);
        verMensagens = (Button) findViewById(R.id.receber);
        ip = (EditText) findViewById(R.id.ip);
        respostaServidor = (TextView) findViewById(R.id.respostaServidor);
        connectPhones.setOnClickListener(connectListener);
        
        ip.setText("192.168.43.");
        
        verMensagens.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				finish();
			}
		});
        
        tt = new TimerTask() {						
        	@Override
        	public void run() {
        		handler.post(new Runnable() {
        			
        			public void run() {
        				respostaServidor.setText(msg);
        			}
        		});
        	}
        };
        timer.schedule(tt, 100, 100);
    }

    private OnClickListener connectListener = new OnClickListener() {

        public void onClick(View v) {
            Thread cThread = new Thread(new UDPClientThread());
            cThread.start();
        }
    };

    public class UDPClientThread implements Runnable {

        public void run() {
            try {
            	InetAddress serverAddr = InetAddress.getByName(ip.getText().toString());
               
            	DatagramSocket socket = new DatagramSocket();
            	byte[] sndData = new byte[1024];
            	byte[] rcvData = new byte[1024];
            	
            	sndData = mensagem.getText().toString().getBytes();
            	
            	DatagramPacket sndPacket = new DatagramPacket(sndData, sndData.length, serverAddr, ServerActivity.SERVERPORT);
            	socket.setBroadcast(true);
            	socket.send(sndPacket);
            	
            	DatagramPacket rcvPacket = new DatagramPacket(rcvData, rcvData.length);
                socket.receive(rcvPacket);
                
                String respFromServer = new String(rcvPacket.getData());
                
                msg = "Resposta: " + respFromServer;
                
                socket.close();
            } catch (Exception e) {
            	e.printStackTrace();
	        }
        }
    }
}

