package tcc.renato.tonny.udpcommunication;


import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Enumeration;
import java.util.Timer;
import java.util.TimerTask;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class ServerActivity extends Activity {
	
	Timer timer = new Timer();
	TimerTask tt;
	final Handler handler = new Handler();
	String mensagem = "";
	
    private TextView serverStatus;
    private Button voltar;
    
    // default ip
    public static String SERVERIP = null;

    // designate a port
    public static final int SERVERPORT = 2806;

    private DatagramSocket serverSocket;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_server);
        serverStatus = (TextView) findViewById(R.id.server_status);
        voltar = (Button) findViewById(R.id.voltar);
        
        Thread t = new Thread(new UDPServerThread());
        t.start();
        
        voltar.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				Intent i = new Intent(getApplicationContext(), ClientActivity.class);
		        startActivity(i);
			}
		});
        
        tt = new TimerTask() {						
        	@Override
        	public void run() {
        		handler.post(new Runnable() {
        			
        			public void run() {
        				serverStatus.setText(mensagem);
        			}
        		});
        	}
        };
        timer.schedule(tt, 100, 100);
    }

    public final class UDPServerThread implements Runnable {

        public void run() {
            try {
            	SERVERIP = getLocalIpAddress();
                if (SERVERIP != null) {
                	mensagem = "Listening on IP: " + SERVERIP;
                    serverSocket = new DatagramSocket(SERVERPORT);
                    byte[] rcvData = new byte[1024];
                    byte[] sndData = new byte[1024];
                    
                    while (true) {
                        // listen for incoming clients
                        DatagramPacket rcvPacket = new DatagramPacket(rcvData, rcvData.length);
                        serverSocket.receive(rcvPacket);
                    	mensagem = "Connected.";
                    	
                    	String line = new String(rcvPacket.getData());
                    	InetAddress IPOrigem = rcvPacket.getAddress();
                    	int portaOrigem = rcvPacket.getPort();
                    	
                    	mensagem = mensagem + "\n" + line;
                    	
                    	String resposta = "Sua mensagem chegou ao destino.";
                    	sndData = resposta.getBytes();
                    	DatagramPacket sndPacket = new DatagramPacket(sndData, sndData.length, IPOrigem, portaOrigem);
                    	serverSocket.send(sndPacket);
                    }
                }
                else {
                	mensagem = "Couldn't detect internet connection.";
                }
            } catch (Exception e) {
            	mensagem = "Error";
                e.printStackTrace();
            }
        }
    }

    
    
    public String getLocalIpAddress() {
        try {
            for (Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces(); en.hasMoreElements();) {
                NetworkInterface intf = en.nextElement();
                for (Enumeration<InetAddress> enumIpAddr = intf.getInetAddresses(); enumIpAddr.hasMoreElements();) {
                    InetAddress inetAddress = enumIpAddr.nextElement();
                    if (!inetAddress.isLoopbackAddress()) { 
                    	return inetAddress.getHostAddress().toString(); 
                    }
                }
            }
        } catch (SocketException ex) {
        	ex.printStackTrace();
        }
   
        return null;
    }

}